.386
.model flat,stdcall
option casemap:none


include \masm32\include\windows.inc 
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\advapi32.inc
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib

include sbhb.inc

.data
szFormat db "%02X",0

.const
PROV_RSA_FULL equ 1
CRYPT_NEWKEYSET equ 8h
HP_HASHVAL equ 2
HP_HASHSIZE equ 4
ALG_CLASS_HASH equ 32768
ALG_TYPE_ANY equ 0
ALG_SID_SHA1 equ 4
SHA1 equ (ALG_CLASS_HASH or ALG_TYPE_ANY or ALG_SID_SHA1)

.code

SBHBDllEntry proc hInstDll:HINSTANCE,reason:DWORD,reserved1:DWORD

	mov eax,TRUE
	ret

SBHBDllEntry endp

GetHashString proc uses ebx esi edi lpInput:LPSTR,lpOutput:LPSTR
	
	
LOCAL hContext		:DWORD
LOCAL hHash			:DWORD 
LOCAL nLen			:DWORD
LOCAL szTemp[256]	:BYTE

	;acquire crypt context
	invoke CryptAcquireContext,addr hContext,NULL,NULL,PROV_RSA_FULL,NULL
	.if eax==FALSE
		;acquire crypt context with new keyset if failed
		invoke CryptAcquireContext,addr hContext,NULL,NULL,PROV_RSA_FULL,CRYPT_NEWKEYSET
	.endif
	.if eax==FALSE
		jmp Exit
	.endif
	;create hash
	invoke CryptCreateHash,hContext,SHA1,0,0,addr hHash
	.if eax==FALSE
		jmp Exit
	.endif
	invoke lstrlen,lpInput
	;hash data
	invoke CryptHashData,hHash,lpInput,eax,0
	.if eax==FALSE
		jmp Exit
	.endif
	;retreive length of hashed data
	invoke CryptGetHashParam,hHash,HP_HASHVAL,NULL,addr nLen,0
	.if eax==FALSE
		jmp Exit
	.endif
	;retreive hashed data
	invoke CryptGetHashParam,hHash,HP_HASHVAL,addr szTemp,addr nLen,0
	.if eax==FALSE
		jmp Exit
	.endif
	;destroy hash
	invoke CryptDestroyHash,hHash
	.if eax==FALSE
		jmp Exit
	.endif
	;release context
	invoke CryptReleaseContext,hContext,NULL
	.if eax==FALSE
		jmp Exit
	.endif
	;translate hash to hexadecimal string
	xor ebx,ebx
	lea esi,szTemp
	mov edi,lpOutput
	_begin:
	movzx ebx,byte ptr [esi]
	invoke wsprintf,edi,addr szFormat,ebx
	inc edi
	inc edi
	inc esi
	xor ebx,ebx
	dec nLen
	cmp nLen,0
	jne _begin
	xor eax,eax
	mov eax,TRUE
Exit:
	ret

GetHashString endp
end SBHBDllEntry
